'use strict';

angular.module('analytics', ['ngCordova', 'logger'])
    .directive('gatrackclick', [
        'tracking',
        function (tracking) {
            return {
                restrict: 'AC',
                scope: {eventvalue: '@'},
                link: function (scope, elem, attrs) {
                    elem.bind('click', function () {
                        tracking.trackEvent('Link', 'Click', scope.eventvalue, 1);
                    });
                }
            };
        }
    ])
    .factory('tracking', function ($platform, $cordovaGoogleAnalytics) {
        return {
            trackEvent: function (category, eventAction, eventLabel, eventValue) {
                $platform.ready(function () {
                    if (!$platform.is('browser')) {
                        $cordovaGoogleAnalytics.trackEvent(category, eventAction, eventLabel, eventValue);
                    }
                });
            },
            trackPage: function (url) {
                $platform.ready(function () {
                    if (!$platform.is('browser')) {
                        $cordovaGoogleAnalytics.trackView(url);
                    }
                });
            },
        };
    })
    /** Tracking location changes **/
    .run([
        '$rootScope', '$location', 'tracking',
        function ($rootScope, $location, tracking) {
            $rootScope.$on('$locationChangeSuccess', function () {
                tracking.trackPage($location.path());
            });
        }
    ])

    /** Tracking App Start **/
    .run([
        '$platform', '$cordovaGoogleAnalytics', 'GAID', 'DEBUG',
        function ($platform, $cordovaGoogleAnalytics, GAID, DEBUG) {
            $platform.ready(function () {
                if (!$platform.is('browser')) {
                    if (DEBUG) {
                        $cordovaGoogleAnalytics.debugMode();
                    }

                    $cordovaGoogleAnalytics.startTrackerWithId(GAID);
                    $cordovaGoogleAnalytics.trackEvent('App', 'Start', 'Start', 1);
                }
            });
        }
    ]);
