
function Database(db, settings) {
    this.db = db(settings.name, settings.version, settings.name, settings.size);
    this.setup();
}

Database.prototype.setup = function() {
    this.db.transaction(function(t) {
        t.executeSql('CREATE TABLE IF NOT EXISTS settings ( key VARCHAR(255) PRIMARY KEY, value VARCHAR(255) )');
    }, this.errorHandler);
};

Database.prototype.save = function(key, value, successCallback) {
    this.db.transaction(function(t) {
        t.executeSql('REPLACE INTO settings (key, value) VALUES (?, ?)', [key, value], successCallback);
    }, this.errorHandler);
};

Database.prototype.get = function(key, callback) {
    this.db.transaction(function(t) {
        t.executeSql('SELECT value FROM settings WHERE key = ?', [key], function(t, results) {
            var value = {};

            if (results.rows.length) {
                value = results.rows.item(0).value;
            }

            callback(value);
        }, this.errorHandler);
    }, this.errorHandler);
};

Database.prototype.errorHandler = function(e) {
    console.log(e);
};