'use strict';

angular.module('spmApp.directives')
    .directive('tankstellen', [
        function () {
            return {
                restrict: 'E',
                scope: {
                    result: '=items',
                    sorte: '=sorte'
                },
                templateUrl: 'app/partials/tankstellen.html',
                controller: function ($timeout, $scope, settings, Favorites, PREMIUM, MARKENLOGOS) {
                    $scope.user = {};
                    $scope.authenticated = false;
                    $scope.clickedFavorites = [];

                    $scope.convertMarke2CSS = function (marke) {
                        return angular.lowercase(marke)
                            .replace(/ /g, '_')
                            .replace(/ä/g, 'ae')
                            .replace(/ö/g, 'oe')
                            .replace(/ü/g, 'ue')
                            .replace(/ß/g, 'ss');
                    };

                    $scope.addFavorite = function (id) {
                        if ($scope.isFavorite(id)) {
                            Favorites.deleteBookmark($scope.user, id)
                                .then(function () {
                                    var i = $scope.clickedFavorites.indexOf(id);
                                    $scope.clickedFavorites.splice(i, 1);
                                });
                        } else {
                            Favorites.addBookmark($scope.user, id)
                                .then(function () {
                                    $scope.clickedFavorites.push(id);
                                });
                        }
                    };

                    $scope.isFavorite = function (id) {
                        return $scope.clickedFavorites.indexOf(id) > -1;
                    };

                    $scope.isPremium = function () {
                        return PREMIUM;
                    };

                    $scope.showMarkenlogos = function () {
                        return MARKENLOGOS;
                    };

                    $timeout(function () {
                        settings.getUser().then(function (user) {
                            $scope.user = user;
                            $scope.authenticated = true;

                            Favorites.getBookmarks(user).then(function (bookmarks) {
                                $scope.clickedFavorites = bookmarks;
                            });
                        });
                    });
                }
            };
        }
    ]);