'use strict';

var directives = angular.module('spmApp.directives', ['phonegap']);

directives.directive('oeffnungszeiten', [
    function () {
        return {
            restrict: 'E',
            scope: {
                tankstelle: '='
            },
            templateUrl: 'app/partials/oeffnungszeiten.html',
            controller: function (Monitor, $scope, $sce) {
                $scope.open = false;

                $scope.openModal = function () {
                    Monitor.getZeiten($scope.tankstelle).then(function (data) {
                        $scope.zeiten = $sce.trustAsHtml(data);
                        $scope.open = true;
                    });
                };

                $scope.closeModal = function () {
                    $scope.open = false;
                };
            }
        };
    }
]);

directives.directive('maplink', [
    '$platform',
    function ($platform) {
        return {
            restrict: 'A',
            scope: {lat: '@', lng: '@'},
            link: function (scope, element) {
                $platform.ready(function() {
                    if ($platform.is('IOS')) {
                        element.attr('href', "maps:q=" + scope.lat + ',' + scope.lng);
                    } else {
                        element.attr('href', "http://maps.google.com/?q=" + scope.lat + ',' + scope.lng);
                    }
                });
            }
        };
    }
]);