'use strict';

angular.module('spmApp.services')
    .service('BannerService', function ($q, $cordovaFile, DatabaseService, $http, AD_URL, PREMIUM) {
        var $this = this;

        this.resolveBanner = function (banner, dbBanner) {
            var d = $q.defer();

            if (!banner.top.enabled) {
                DatabaseService.save('banner.top', {enabled: false})
                d.reject();
            } else if (banner.top.image === dbBanner.image && banner.top.href === dbBanner.href && banner.top.enabled === dbBanner.enabled) {
                d.resolve(dbBanner);
            } else {
                $cordovaFile.createFile('top.jpg').then(function (fileEntry) {
                    $cordovaFile.downloadFile(banner.top.image, fileEntry.toURL())
                        .then(function (entry) {
                            $cordovaFile.readAsDataURL(entry.fullPath)
                                .then(function (evt) {
                                    var value = {
                                        image: banner.top.image,
                                        href: banner.top.href,
                                        alt: banner.top.alt,
                                        enabled: banner.top.enabled,
                                        base64: evt.target.result
                                    };

                                    DatabaseService.save('banner.top', value)
                                        .then(d.resolve, d.reject);

                                }, d.reject);
                        }, d.reject);
                }, d.reject);
            }

            return d.promise;
        };
        this.retrieveBannerImg = function () {
            var d = $q.defer();

            $http.get(AD_URL, {
                cache: true
            }).success(function (banner) {
                DatabaseService.get('banner.top')
                    .then(function (dbBanner) {
                        $this.resolveBanner(banner, dbBanner).then(d.resolve, d.reject);
                    }, function () {
                        $this.resolveBanner(banner, {}).then(d.resolve, d.reject);
                    });
            }).error(d.reject);

            return d.promise;
        };

        this.getBanner = function () {
            var d = $q.defer();

            if (true === PREMIUM) {
                d.reject();
            }

            DatabaseService.get('banner.top')
                .then(function (banner) {
                    if (true === banner.enabled) {
                        d.resolve(banner);
                    } else {
                        d.reject();
                    }
                }, d.reject);

            return d.promise;
        };
    });