'use strict';

angular.module('spmApp.services')
    .service('DatabaseService', function($q, database, _) {
        this.get = function(key) {
            var d = $q.defer();

            database.get(function(datebase) {
                datebase.get(key, function(value) {
                    value = angular.fromJson(value);
                    if (_.isEmpty(value)) {
                        d.reject();
                    } else {
                        d.resolve(value);
                    }
                }, function(error) {
                    d.reject(error);
                });
            });

            return d.promise;
        };
        this.save = function(key, value) {
            var d = $q.defer();

            database.get(function(datebase) {
                value = angular.toJson(value);
                datebase.save(key, value, function(value) {
                    d.resolve(value);
                });
            });

            return d.promise;
        };
    });